--- linux-2.4.26/include/asm-s390x/kmap_types.h	(revision 0)
+++ linux-2.4.26-s390/include/asm-s390x/kmap_types.h	(revision 19)
@@ -0,0 +1,16 @@
+#ifndef _ASM_KMAP_TYPES_H
+#define _ASM_KMAP_TYPES_H
+
+enum km_type {
+	KM_BOUNCE_READ,
+	KM_SKB_SUNRPC_DATA,
+	KM_SKB_DATA_SOFTIRQ,
+	KM_USER0,
+	KM_USER1,
+	KM_BH_IRQ,
+	KM_SOFTIRQ0,
+	KM_SOFTIRQ1,
+	KM_TYPE_NR
+};
+
+#endif
--- linux-2.4.26/include/asm-s390/kmap_types.h	(revision 0)
+++ linux-2.4.26-s390/include/asm-s390/kmap_types.h	(revision 19)
@@ -0,0 +1,16 @@
+#ifndef _ASM_KMAP_TYPES_H
+#define _ASM_KMAP_TYPES_H
+
+enum km_type {
+	KM_BOUNCE_READ,
+	KM_SKB_SUNRPC_DATA,
+	KM_SKB_DATA_SOFTIRQ,
+	KM_USER0,
+	KM_USER1,
+	KM_BH_IRQ,
+	KM_SOFTIRQ0,
+	KM_SOFTIRQ1,
+	KM_TYPE_NR
+};
+
+#endif
--- linux-2.4.26.test/arch/s390/appldata/appldata_base.c.orig	2004-05-27 22:16:20.000000000 -0400
+++ linux-2.4.26.test/arch/s390/appldata/appldata_base.c	2004-05-28 01:49:10.000000000 -0400
@@ -640,7 +640,6 @@
 	val->freeswap = -1ul;
 	val->totalswap = -1ul;
 }
-atomic_t page_cache_size = ATOMIC_INIT(-1);
 unsigned long avenrun[3] = {-1 - FIXED_1/200, -1 - FIXED_1/200,
 				-1 - FIXED_1/200};
 int nr_threads = -1;
--- linux-2.4.26.test/arch/s390/appldata/appldata_mem.c.orig	2004-05-27 22:16:20.000000000 -0400
+++ linux-2.4.26.test/arch/s390/appldata/appldata_mem.c	2004-05-28 01:49:33.000000000 -0400
@@ -100,7 +100,7 @@
 	mem_data->totalhigh = P2K(val.totalhigh);
 	mem_data->freehigh  = P2K(val.freehigh);
 	mem_data->bufferram = P2K(val.bufferram);
-	mem_data->cached    = P2K(atomic_read(&page_cache_size) -
+	mem_data->cached    = P2K(page_cache_size -
 					val.bufferram);
 
 	si_swapinfo(&val);
